; aa punctuation
; ab kanji 1
; ad hiragana
;
alias txt2euc {
  unset %euc.j
  :loop
  if $asc($left(%euc.e,1)) isnum 65-90 { ae.enc }
  elseif $asc($left(%euc.e,1)) isnum 97-122 { ad.enc }
  elseif $left(%euc.e,1) isnum { ac.enc }
  elseif $left(%euc.e,1) == ` { ab.enc }
  else { aa.enc }
  ;
  if $len(%euc.e) < 1 { return }
  ;
  :end
  if $result isnum {
    if $len(%euc.e) < 1 { return }
    set %euc.e $right(%euc.e,$calc( $len(%euc.e) - $result ))
  }
  elseif $result == error {
    echo -s Error encoding Japanese - invalid character 
    if $len(%euc.e) < 1 { return }
    set %euc.e $right(%euc.e,$calc( $len(%euc.e) - 1 ))
  }
  elseif $result == kanjinai {
    ; echo -s Error encoding Japanese - this kanji has no shortcut
    if $len(%euc.e) < 1 { return }
    set %euc.e $right(%euc.e,$calc( $len(%euc.e) - 1 ))
  }
  goto loop
}
alias aa.enc {
  if $left(%euc.e,1) == $chr(32) { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == $chr(160) { set %euc.j %euc.j $+  | return 1 }
  ;
  if $left(%euc.e,1) == ! { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == " { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == $chr(35) { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == $chr(36) { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == % { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == & { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == ' { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == ( { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == ) { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == $chr(42) { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == + { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == , { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == - { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == . {
    if $left(%euc.e,1) == ... { set %euc.j %euc.j $+  | return 3 }
    if $left(%euc.e,1) == .. { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,1) == . { set %euc.j %euc.j $+  | return 1 }
  }
  if $left(%euc.e,1) == / { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == : { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == ; { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == $chr(60) { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == $chr(61) { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == $chr(62) { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == $chr(63) { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == $chr(64) { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == $chr(91) { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == \ { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == $chr(93) { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == ^ { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == _ { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == $chr(123) { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == $chr(124) { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == $chr(125) { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == ~ { set %euc.j %euc.j $+  | return 1 }
  return error
}
alias ab.enc {
  if $left(%euc.e,3) == `as {
    if $left(%euc.e,6) == `asita { set %euc.j %euc.j $+  | return 6 }
    if $left(%euc.e,7) == `ashita { set %euc.j %euc.j $+  | return 7 }
  }
  if $left(%euc.e,5) == `baka { set %euc.j %euc.j $+ ϼ | return 5 }
  if $left(%euc.e,8) == `benkyou {
    if $left(%euc.e,12) == `benkyouchuu { set %euc.j %euc.j $+ ٶ | return 12 }
    if $left(%euc.e,10) == `benkyouka { set %euc.j %euc.j $+ ٶ | return 10 }
    if $left(%euc.e,8) == `benkyou { set %euc.j %euc.j $+ ٶ | return 8 }
  }
  if $left(%euc.e,5) == `boku {
    set %t $?="1   2   3   4   5   6   7   8   9   a ܤ"
    if $! == 1 { set %euc.j %euc.j $+  }
    elseif $! == 2 { set %euc.j %euc.j $+  }
    elseif $! == 3 { set %euc.j %euc.j $+  }
    elseif $! == 4 { set %euc.j %euc.j $+  }
    elseif $! == 5 { set %euc.j %euc.j $+  }
    elseif $! == 6 { set %euc.j %euc.j $+  }
    elseif $! == 7 { set %euc.j %euc.j $+  }
    elseif $! == 8 { set %euc.j %euc.j $+  }
    elseif $! == 9 { set %euc.j %euc.j $+  }
    else { set %euc.j %euc.j $+ ܤ }
    return 5
  }
  if $left(%euc.e,5) == `dare { set %euc.j %euc.j $+ ï | return 5 }
  if $left(%euc.e,5) == `eigo {
    if $left(%euc.e,10) == `eigokujin { set %euc.j %euc.j $+ ѹ | return 10 }
    ; multiple kanji for phoneme eigo
    if $left(%euc.e,5) == `eigo { set %euc.j %euc.j $+ Ѹ | return 5 }
  }
  if $left(%euc.e,4) == `gai {
    if $left(%euc.e,6) == `gaigo { set %euc.j %euc.j $+  | return 6 }
    if $left(%euc.e,7) == `gaijin { set %euc.j %euc.j $+  | return 7 }
    if $left(%euc.e,8) == `gaikoku {
      if $left(%euc.e,10) == `gaikokugo { set %euc.j %euc.j $+  | return 10 }
      if $left(%euc.e,11) == `gaikokujin { set %euc.j %euc.j $+  | return 11 }
      if $left(%euc.e,8) == `gaikoku { set %euc.j %euc.j $+  | return 8 }
    }
  }
  if $left(%euc.e,6) == `genki { set %euc.j %euc.j $+  | return 6 }
  if $left(%euc.e,7) == `honjit {
    if $left(%euc.e,8) == `honjitu { set %euc.j %euc.j $+  | return 8 }
    if $left(%euc.e,9) == `honjitsu { set %euc.j %euc.j $+  | return 9 }
  }
  if $left(%euc.e,8) == `igirisu { set %euc.j %euc.j $+ ѵ | return 8 }
  if $left(%euc.e,2) == `k {
    ; multiple kanji for phoneme kanji
    if $left(%euc.e,6) == `kanji { set %euc.j %euc.j $+  | return 6 }
    if $left(%euc.e,7) == `konban {
      if $left(%euc.e,9) == `konbanha { set %euc.j %euc.j $+ դ | return 9 }
      if $left(%euc.e,9) == `konbanwa { set %euc.j %euc.j $+ դ | return 9 }
    }
    if $left(%euc.e,6) == `konni {
      if $left(%euc.e,11) == `konnichiwa { set %euc.j %euc.j $+  | return 11 }
      if $left(%euc.e,10) == `konnitiwa { set %euc.j %euc.j $+  | return 10 }
      if $left(%euc.e,11) == `konnichiha { set %euc.j %euc.j $+  | return 11 }
      if $left(%euc.e,10) == `konnitiha { set %euc.j %euc.j $+  | return 10 }
    }
    if $left(%euc.e,7) == `konoma { set %euc.j %euc.j $+  | return 7 }
    if $left(%euc.e,7) == `konomi { set %euc.j %euc.j $+  | return 7 }
    if $left(%euc.e,7) == `kudasa { set %euc.j %euc.j $+  | return 7 }
  }
  if $left(%euc.e,2) == `n {
    ; multiple kanji for phoneme namae
    if $left(%euc.e,6) == `namae { set %euc.j %euc.j $+ ̾ | return 6 }
    if $left(%euc.e,6) == `nihon {
      if $left(%euc.e,8) == `nihongo { set %euc.j %euc.j $+ ܸ | return 8 }
      if $left(%euc.e,9) == `nihonjin { set %euc.j %euc.j $+ ܿ | return 9 }
      ; multiple kanji for phoneme nihon
      if $left(%euc.e,6) == `nihon { set %euc.j %euc.j $+  | return 9 }
    }
    if $left(%euc.e,7) == `nippon {
      if $left(%euc.e,9) == `nippongo { set %euc.j %euc.j $+ ܸ | return 9 }
      if $left(%euc.e,10) == `nipponjin { set %euc.j %euc.j $+ ܿ | return 10 }
      if $left(%euc.e,7) == `nippon { set %euc.j %euc.j $+  | return 7 }
    }
  }
  if $left(%euc.e,2) == `o {
    if $left(%euc.e,5) == `omae { set %euc.j %euc.j $+  | return 5 }
    if $left(%euc.e,7) == `oosaka { set %euc.j %euc.j $+  | return 7 }
  }
  if $left(%euc.e,8) == `sakujit {
    if $left(%euc.e,10) == `sakujitsu { set %euc.j %euc.j $+  | return 10 }
    if $left(%euc.e,9) == `sakujitu { set %euc.j %euc.j $+  | return 9 }
  }
  if $left(%euc.e,6) == `sugoi { set %euc.j %euc.j $+  | return 6 }
  if $left(%euc.e,2) == `t {
    if $left(%euc.e,7) == `tabesu { set %euc.j %euc.j $+ ٲ | return 7 }
    if $left(%euc.e,6) == `totei { set %euc.j %euc.j $+  | return 6 }
    if $left(%euc.e,8) == `toukyou { set %euc.j %euc.j $+  | return 8 }
  }
  if $left(%euc.e,2) == `w {
    if $left(%euc.e,5) == `wara {
      if $left(%euc.e,10) == `warabeuta { set %euc.j %euc.j $+ Ƹ | return 10 }
      if $left(%euc.e,7) == `warabe { set %euc.j %euc.j $+ Ƹ | return 7 }
      if $left(%euc.e,6) == `warau { set %euc.j %euc.j $+ Ф | return 6 }
      if $left(%euc.e,6) == `warai { set %euc.j %euc.j $+ Ф | return 6 }
      if $left(%euc.e,7) == `warawa { set %euc.j %euc.j $+  | return 7 }
    }
    if $left(%euc.e,6) == `watas {
      if $left(%euc.e,7) == `watasi { set %euc.j %euc.j $+  | return 7 }
      if $left(%euc.e,8) == `watashi { set %euc.j %euc.j $+  | return 8 }
      if $left(%euc.e,9) == `watakusi { set %euc.j %euc.j $+  | return 9 }
      if $left(%euc.e,10) == `watakushi { set %euc.j %euc.j $+  | return 10 }
    }
  }
  return kanjinai
}
alias ad.enc {
  ; hiragana
  if $left(%euc.e,1) == a { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == i { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == u { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == e { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == o { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == k {
    if $left(%euc.e,2) == ky {
      if $left(%euc.e,3) == kya { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == kyi { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == kyu { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == kye { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == kyo { set %euc.j %euc.j $+  | return 3 }
    }
    if $left(%euc.e,2) == ka { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == ki { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == ku { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == ke { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == ko { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == kk { set %euc.j %euc.j $+  | return 1 }
    if $left(%euc.e,1) == k { set %euc.j %euc.j $+  | return 1 }
  }
  if $left(%euc.e,1) == g {
    if $left(%euc.e,2) == gy {
      if $left(%euc.e,3) == gya { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == gyi { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == gyu { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == gye { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == gyo { set %euc.j %euc.j $+  | return 3 }
    }
    if $left(%euc.e,2) == ga { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == gi { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == gu { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == ge { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == go { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == gg { set %euc.j %euc.j $+  | return 1 }
    if $left(%euc.e,1) == g { set %euc.j %euc.j $+  | return 1 }
  }
  if $left(%euc.e,1) == s {
    if $left(%euc.e,2) == sy {
      if $left(%euc.e,3) == sya { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == syi { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == syu { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == sye { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == syo { set %euc.j %euc.j $+  | return 3 }
    }
    if $left(%euc.e,2) == sh {
      if $left(%euc.e,3) == sha { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == shi { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == shu { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == she { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == sho { set %euc.j %euc.j $+  | return 3 }
    }
    if $left(%euc.e,2) == sa { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == si { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == su { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == se { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == so { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == ss { set %euc.j %euc.j $+  | return 1 }
    if $left(%euc.e,1) == s { set %euc.j %euc.j $+  | return 1 }
  }
  if $left(%euc.e,1) == j {
    if $left(%euc.e,2) == ja { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == ji { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == ju { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == je { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == jo { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == jj { set %euc.j %euc.j $+  | return 1 }
    if $left(%euc.e,1) == j { set %euc.j %euc.j $+  | return 1 }
  }
  if $left(%euc.e,1) == z {
    if $left(%euc.e,2) == zy {
      if $left(%euc.e,3) == zya { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == zyi { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == zyu { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == zye { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == zyo { set %euc.j %euc.j $+  | return 3 }
    }
    if $left(%euc.e,2) == za { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == zi { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == zu { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == ze { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == zo { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == zz { set %euc.j %euc.j $+  | return 1 }
    if $left(%euc.e,1) == z { set %euc.j %euc.j $+  | return 1 }
  }
  if $left(%euc.e,1) == c {
    if $left(%euc.e,2) == ch {
      if $left(%euc.e,3) == cha { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == chi { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == chu { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == che { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == cho { set %euc.j %euc.j $+  | return 3 }
    }
    if $left(%euc.e,2) == cc { set %euc.j %euc.j $+  | return 1 }
    if $left(%euc.e,1) == c { set %euc.j %euc.j $+  | return 1 }
  }
  if $left(%euc.e,1) == t {
    if $left(%euc.e,2) == ty {
      if $left(%euc.e,3) == tya { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == tyi { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == tyu { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == tye { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == tyo { set %euc.j %euc.j $+  | return 3 }
    }
    if $left(%euc.e,1) == t {
      if $left(%euc.e,2) == ta { set %euc.j %euc.j $+  | return 2 }
      if $left(%euc.e,2) == ti { set %euc.j %euc.j $+  | return 2 }
      if $left(%euc.e,2) == tu { set %euc.j %euc.j $+  | return 2 }
      if $left(%euc.e,2) == te { set %euc.j %euc.j $+  | return 2 }
      if $left(%euc.e,2) == to { set %euc.j %euc.j $+  | return 2 }
    }
    if $left(%euc.e,3) == tsu { set %euc.j %euc.j $+  | return 3 }
    if $left(%euc.e,2) == tt { set %euc.j %euc.j $+  | return 1 }
    if $left(%euc.e,2) == tc { set %euc.j %euc.j $+  | return 1 }
    if $left(%euc.e,1) == t { set %euc.j %euc.j $+  | return 1 }
  }
  if $left(%euc.e,1) == d {
    if $left(%euc.e,2) == dy {
      if $left(%euc.e,3) == dya { set %euc.j %euc.j $+ ¤ | return 3 }
      if $left(%euc.e,3) == dyi { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == dyu { set %euc.j %euc.j $+ ¤ | return 3 }
      if $left(%euc.e,3) == dye { set %euc.j %euc.j $+ ¤ | return 3 }
      if $left(%euc.e,3) == dyo { set %euc.j %euc.j $+ ¤ | return 3 }
    }
    if $left(%euc.e,2) == dz {
      if $left(%euc.e,3) == dza { set %euc.j %euc.j $+ ¤ | return 3 }
      if $left(%euc.e,3) == dzi { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == dzu { set %euc.j %euc.j $+ ¤ | return 3 }
      if $left(%euc.e,3) == dze { set %euc.j %euc.j $+ ¤ | return 3 }
      if $left(%euc.e,3) == dzo { set %euc.j %euc.j $+ ¤ | return 3 }
    }
    if $left(%euc.e,2) == da { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == di { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == du { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == de { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == do { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == dd { set %euc.j %euc.j $+  | return 1 }
    if $left(%euc.e,1) == d { set %euc.j %euc.j $+  | return 1 }
  }
  if $left(%euc.e,1) == n {
    if $left(%euc.e,2) == ny {
      if $left(%euc.e,3) == nya { set %euc.j %euc.j $+ ˤ | return 3 }
      if $left(%euc.e,3) == nyi { set %euc.j %euc.j $+ ˤ | return 3 }
      if $left(%euc.e,3) == nyu { set %euc.j %euc.j $+ ˤ | return 3 }
      if $left(%euc.e,3) == nye { set %euc.j %euc.j $+ ˤ | return 3 }
      if $left(%euc.e,3) == nyo { set %euc.j %euc.j $+ ˤ | return 3 }
    }
    if $left(%euc.e,2) == na { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == ni { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == nu { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == ne { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == no { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == n' { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,1) == n { set %euc.j %euc.j $+  | return 1 }
  }
  if $left(%euc.e,1) == f {
    if $left(%euc.e,2) == fa { set %euc.j %euc.j $+ դ | return 2 }
    if $left(%euc.e,2) == fi { set %euc.j %euc.j $+ դ | return 2 }
    if $left(%euc.e,2) == fu { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == fe { set %euc.j %euc.j $+ դ | return 2 }
    if $left(%euc.e,2) == fo { set %euc.j %euc.j $+ դ | return 2 }
    if $left(%euc.e,2) == ff { set %euc.j %euc.j $+  | return 1 }
    if $left(%euc.e,1) == f { set %euc.j %euc.j $+  | return 1 }
  }
  if $left(%euc.e,1) == h {
    if $left(%euc.e,2) == hy {
      if $left(%euc.e,3) == hya { set %euc.j %euc.j $+ Ҥ | return 3 }
      if $left(%euc.e,3) == hyi { set %euc.j %euc.j $+ Ҥ | return 3 }
      if $left(%euc.e,3) == hyu { set %euc.j %euc.j $+ Ҥ | return 3 }
      if $left(%euc.e,3) == hye { set %euc.j %euc.j $+ Ҥ | return 3 }
      if $left(%euc.e,3) == hyo { set %euc.j %euc.j $+ Ҥ | return 3 }
    }
    if $left(%euc.e,2) == ha { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == hi { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == hu { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == he { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == ho { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == hh { set %euc.j %euc.j $+  | return 1 }
    if $left(%euc.e,1) == h { set %euc.j %euc.j $+  | return 1 }
  }
  if $left(%euc.e,1) == b {
    if $left(%euc.e,2) == by {
      if $left(%euc.e,3) == bya { set %euc.j %euc.j $+ Ӥ | return 3 }
      if $left(%euc.e,3) == byi { set %euc.j %euc.j $+ Ӥ | return 3 }
      if $left(%euc.e,3) == byu { set %euc.j %euc.j $+ Ӥ | return 3 }
      if $left(%euc.e,3) == bye { set %euc.j %euc.j $+ Ӥ | return 3 }
      if $left(%euc.e,3) == byo { set %euc.j %euc.j $+ Ӥ | return 3 }
    }
    if $left(%euc.e,2) == ba { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == bi { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == bu { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == be { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == bo { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == bb { set %euc.j %euc.j $+  | return 1 }
    if $left(%euc.e,1) == b { set %euc.j %euc.j $+  | return 1 }
  }
  if $left(%euc.e,1) == p {
    if $left(%euc.e,2) == py {
      if $left(%euc.e,3) == pya { set %euc.j %euc.j $+ Ԥ | return 3 }
      if $left(%euc.e,3) == pyi { set %euc.j %euc.j $+ Ԥ | return 3 }
      if $left(%euc.e,3) == pyu { set %euc.j %euc.j $+ Ԥ | return 3 }
      if $left(%euc.e,3) == pye { set %euc.j %euc.j $+ Ԥ | return 3 }
      if $left(%euc.e,3) == pyo { set %euc.j %euc.j $+ Ԥ | return 3 }
    }
    if $left(%euc.e,2) == pa { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == pi { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == pu { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == pe { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == po { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == pp { set %euc.j %euc.j $+  | return 1 }
    if $left(%euc.e,1) == p { set %euc.j %euc.j $+  | return 1 }
  }
  if $left(%euc.e,1) == m {
    if $left(%euc.e,2) == my {
      if $left(%euc.e,3) == mya { set %euc.j %euc.j $+ ߤ | return 3 }
      if $left(%euc.e,3) == myi { set %euc.j %euc.j $+ ߤ | return 3 }
      if $left(%euc.e,3) == myu { set %euc.j %euc.j $+ ߤ | return 3 }
      if $left(%euc.e,3) == mye { set %euc.j %euc.j $+ ߤ | return 3 }
      if $left(%euc.e,3) == myo { set %euc.j %euc.j $+ ߤ | return 3 }
    }
    if $left(%euc.e,2) == ma { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == mi { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == mu { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == me { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == mo { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == mm { set %euc.j %euc.j $+  | return 1 }
    if $left(%euc.e,1) == m { set %euc.j %euc.j $+  | return 1 }
  }
  if $left(%euc.e,1) == y {
    if $left(%euc.e,2) == ya { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == yu { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == yo { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == yy { set %euc.j %euc.j $+  | return 1 }
    if $left(%euc.e,1) == y { set %euc.j %euc.j $+  | return 1 }
  }
  if $left(%euc.e,1) == r {
    if $left(%euc.e,2) == ry {
      if $left(%euc.e,3) == rya { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == ryi { set %euc.j %euc.j $+ ꤣ | return 3 }
      if $left(%euc.e,3) == ryu { set %euc.j %euc.j $+  | return 3 }
      if $left(%euc.e,3) == rye { set %euc.j %euc.j $+ ꤧ | return 3 }
      if $left(%euc.e,3) == ryo { set %euc.j %euc.j $+  | return 3 }
    }
    if $left(%euc.e,2) == ra { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == ri { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == ru { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == re { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == ro { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == rr { set %euc.j %euc.j $+  | return 1 }
    if $left(%euc.e,1) == r { set %euc.j %euc.j $+  | return 1 }
  }
  if $left(%euc.e,1) == w {
    if $left(%euc.e,2) == wa { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == wi { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == we { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == wo { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == ww { set %euc.j %euc.j $+  | return 1 }
    if $left(%euc.e,1) == w { set %euc.j %euc.j $+  | return 1 }
  }
  if $left(%euc.e,1) == v {
    if $left(%euc.e,2) == va { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == vi { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == vu { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == ve { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == vo { set %euc.j %euc.j $+  | return 2 }
    if $left(%euc.e,2) == vv { set %euc.j %euc.j $+  | return 1 }
    if $left(%euc.e,1) == v { set %euc.j %euc.j $+  | return 1 }
  }
  if $left(%euc.e,1) == l { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == q { set %euc.j %euc.j $+  | return 1 }
  if $left(%euc.e,1) == x { set %euc.j %euc.j $+  | return 1 }
  return error
}
